unit Test;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FireDAC.Stan.Def,
  FMX.TMSBaseControl, FMX.TMSGridCell, FMX.TMSGridOptions, FMX.TMSGridData,
  FMX.TMSCustomGrid, FMX.TMSGrid, FMX.TMSBitmapContainer;

type
  TfrmTest = class(TForm)
    Grd: TTMSFMXGrid;
    TMSFMXBitmapContainer1: TTMSFMXBitmapContainer;
    procedure FormCreate(Sender: TObject);
    procedure GrdFixedCellClick(Sender: TObject; ACol, ARow: Integer);
  private
    { Private declarations }
  public
    glbDataPath: String;
    { Public declarations }
  end;

var
  frmTest: TfrmTest;

implementation

{$R *.fmx}

procedure TfrmTest.FormCreate(Sender: TObject);
var
DataPath: String;
I: Integer;
Ptr: ^Boolean;
begin
    Grd.RowCount := 10;
    Grd.ColumnCount := 1;
    for I := 0 to Grd.RowCount - 1 do
    begin
      Grd.AllCells[0,I] := 'P: ' + IntToStr(I);
      if I In [1,7] then
      begin
        Grd.AddBitmap(0,I,'Plus');
        New(Ptr);
        Ptr^ := True;
        Grd.Objects[0,I] := TObject(Ptr);
      end;
    end;
end;

procedure TfrmTest.GrdFixedCellClick(Sender: TObject; ACol, ARow: Integer);
var
Ptr: ^Boolean;
begin
  Grd.BeginUpdate;
  if Grd.IsBitmap(ACol,ARow) then
  begin
    if Grd.GetBitmapName(ACol,ARow) = 'Plus' then
    begin
      Grd.AddBitmap(ACol,ARow,'Minus');
      Ptr := Pointer(Grd.Objects[ACol,ARow]);
      if Ptr^ then
      begin
        Grd.InsertRows(ARow + 1,2);
        Ptr^ := False;
        Grd.Objects[0,ARow] := TObject(Ptr);
      end
      else
        Grd.UnHideRows(ARow + 1,2);
    end
    else
    begin
      Grd.AddBitmap(ACol,ARow,'Plus');
      Grd.HideRows(ARow + 1,2);
    end;
  end;
  Grd.EndUpdate;
end;

end.
